/* Copyright (C) 2008 severalnines.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef ALARM_H
#define ALARM_H

#include <mgmapi.h>
#include <cmon.h>
#include <connect.h>


enum memory_area{IM, DM};

bool db_write_alarm( mysql_t * mysql,
		     const int cluster_id,  
		     const int nodeid, 
		     const int curr_cluster_state,
		     const int prev_cluster_state,
		     const char * severity, 
		     const char * component, 
		     const char * alarm_name, 
		     const char * exit_message,
		     const char * description,
		     const char * reco);

bool db_check_cluster_alarm( mysql_t * mysql);
bool db_check_node_alarm(const int nodeid,   mysql_t * mysql);



bool db_write_resource_alarm( mysql_t * mysql,
			      const int nodeid, 		     
			      const char * severity, 
			      const char * resource, 
			      const char * alarm_name, 
			      const char * node_type,
			      const char * description,
			      const char * reco);


bool db_clear_resource_alarm( mysql_t * mysql,
			      const int nodeid, 		     
			      const char * resource,
			      const char * descr);


bool db_cluster_clear_alarm( mysql_t * mysql);



bool db_node_clear_alarm( mysql_t * mysql,
			   const int nodeid,
			   const char * node_type,
			   const char * severity,
			   const char * alarm_name);

bool db_update_alarm_count( mysql_t * mysql,
			    const int nodeid);

bool db_update_alarm_error( mysql_t * mysql,
			    const int nodeid,
			    const char * exit_msg,
			    const char * desc,
			    const char * rec);

unsigned long long db_get_alarm_id( mysql_t * mysql,
				    const int cluster_id,  
				    const int nodeid, 
				    const char * component, 
				    const char * alarm_name);

unsigned long long db_get_last_inserted_alarm_id( mysql_t * mysql);

#endif
