/* Copyright (C) 2008 severalnines.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



#ifndef CONNECT_H
#define CONNECT_H
#include "cmon.h"
#include <unistd.h>
#include <stdlib.h>


extern configparam_t params;
extern mysql_t mysql_conn[MAX_THREADS];
extern cluster_t cluster_state;
extern cluster_conn_t cluster_conn[2];

extern Ndb_cluster_connection  * g_ndb_conn;
extern Ndb * g_ndb;

void get_hostname(char * hostname);
bool test_connect();
int  connect_ndb();
void disconnectMySQL(mysql_t  * mysql);
bool connectMySQL(mysql_t * mysql);
bool connectMySQL2(MYSQL * mysql, const char * db );
bool connectMySQL3(MYSQL * mysql, 
		   const char * hostname,
		   const char * username,
		   const char * password,
		   int port
		   );
bool connectMySQL4(MYSQL * mysql, 
		   const char * hostname,
		   const char * username,
		   const char * password,
		   const char * socket,
		   int port
		   );
bool executeQuery(const char * query , mysql_t * mysql);
bool executeQuery2(const char * query , MYSQL * mysql);
bool connectNdbMgm(cluster_conn_t * conn );
bool is_mysqld(const unsigned int nodeid, mysql_t * mysql);

bool db_check_node_exists(const int nodeid,   mysql_t * mysql);
bool db_get_ndbd_hostname(const int nodeid,  char * hostname,  mysql_t * mysql);
void db_write_ndbd_nodestate(const int nodeid, const int node_group, const int version,
			     const char * status, const char * connect_addr,  mysql_t * mysql);
bool db_get_ndbd_state(const int nodeid,  char * status,  mysql_t * mysql);
#endif
