#ifndef CMON_HANDLER_H
#define CMON_HANDLER_H

/*
 * Option handling
 * and init of plugin
 * ret: <0  - failure, else success
 */


#include "config.h"
#if HAVE_DLFCN_H 
#include <dlfcn.h>
#include "statistics.h"
#endif

struct handler_list_t
{
  void * handle;
  char name[256];
};



extern int g_plugin_count;
extern struct handler_list_t *  g_handler_list;

int handler_initialize(const char ** argv, const int argc, int plugin);

void raise_alarm();
void clear_alarm();


void handler_backup_event(int nodeid, 
			  statistics_backup_t backup_stats);

void handler_restore_event(int nodeid, 
			   statistics_restore_t restore_stats);


void handler_memory_usage_event(int nodeid, 
				statistics_mem_t mem_stats);


void handler_node_statistics(int nodeid,
			     statistics_t perf_stats);

void handler_log_message(int loglevel, const char *);


void handler_raise_alarm_node_fail(int nodeid, 				  
				   const char * c_prev_state,
				   const char * c_state,
				   const char * current_state);

void handler_clear_alarm_node_fail(int nodeid, 
				   const char * c_prev_state,
				   const char * c_state,
				   const char * current_state);

#endif
