/* Copyright (C) 2008 severalnines.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#ifndef MYSQL_COLL_H
#define MYSQL_COLL_H


static const char * status_vars[]=
  {
    "ABORTED_CLIENTS",
    "ABORTED_CONNECTS",
    "BINLOG_CACHE_DISK_USE",
    "BINLOG_CACHE_USE",
    "BYTES_RECEIVED",
    "BYTES_SENT",
    "COM_CREATE_TABLE",
    "COM_DELETE",
    "COM_DROP_TABLE",
    "COM_INSERT",
    "COM_INSERT_SELECT",
    "COM_REPLACE",
    "COM_REPLACE_SELECT",
    "COM_SELECT",
    "COM_UPDATE",
    "COM_UPDATE_MULTI",
    "CONNECTIONS",
    "CREATED_TMP_DISK_TABLES",
    "CREATED_TMP_FILES",
    "CREATED_TMP_TABLES",
    "HANDLER_COMMIT",
    "HANDLER_DELETE",
    "HANDLER_READ_FIRST",
    "HANDLER_READ_KEY",
    "HANDLER_READ_NEXT",
    "HANDLER_READ_PREV",
    "HANDLER_READ_RND",
    "HANDLER_READ_RND_NEXT",
    "HANDLER_UPDATE",
    "HANDLER_WRITE",
    "KEY_BLOCKS_NOT_FLUSHED",
    "KEY_BLOCKS_UNUSED",
    "KEY_BLOCKS_USED",
    "KEY_READ_REQUESTS",
    "KEY_READS",
    "KEY_WRITE_REQUESTS",
    "KEY_WRITES",
    "MAX_USED_CONNECTIONS",
    "OPEN_TABLE_DEFINITIONS",
    "OPEN_TABLES",
    "OPENED_FILES",
    "OPENED_TABLE_DEFINITIONS",
    "OPENED_TABLES",
    "QUERIES",
    "QUESTIONS",
    "SELECT_FULL_JOIN",
    "SELECT_FULL_RANGE_JOIN",
    "SELECT_RANGE",
    "SELECT_RANGE_CHECK",
    "SELECT_SCAN",
    "SORT_MERGE_PASSES",
    "SORT_RANGE",
    "SORT_ROWS",
    "SORT_SCAN",
    "TABLE_LOCKS_IMMEDIATE",
    "TABLE_LOCKS_WAITED",
    "THREADS_CACHED",
    "THREADS_CONNECTED",
    "THREADS_CREATED",
    "THREADS_RUNNING",
    "UPTIME" 
  };

void * mysql_collector_thread(void * t);

void collect_mysql_stats(const int id,
			 const int nodeid,
			 const char * hostname,
			 const char * username, 
			 const char * password,
			 const char * role,
			 const int port);

void collect_mysql_slave_stats(const int id,
			       const char * hostname,
			       const char * username, 
			       const char * password, 
			       const int port,
			       const char * role);


void collect_mysql_master_stats(const int id,
				const char * hostname,
				const char * username, 
				const char * password, 
				const int port,
				const char * role);


void collect_mysql_variables(const int mysqlid,
			     const char * hostname,
			     const char * username, 
			     const char * password, 
			     const char * role,
			     const int port);

void update_status(unsigned int cid, unsigned int nodeid, bool is_connected, const char * msg);
void update_status2(unsigned int cid, const char * hostname, int port,  bool is_connected, const char * msg);

int update_server_tbl(const unsigned int cid,const unsigned int id, const  char * hostname, 
		      const char * username, const char * password, const unsigned int port);

void update_server_tbl_set_role(const unsigned int cid,const unsigned int id, const  char * hostname, 
				const char * username, const char * password, const unsigned int port, const char * role);

void insert_stats_tbl(unsigned int cid, unsigned int id, unsigned int nodeid);
void insert_slave_stats_tbl(unsigned int cid, unsigned int id);
void insert_master_stats_tbl(unsigned int cid, unsigned int id);

#endif
