/* Copyright (C) 2008 severalnines.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef SCHEMA_H
#define SCHEMA_H



static const char * TABLES[]=
  {
    "alarm",
    "alarm_log",
    "backup",
    "backup_log",
    "email_notification",
    "restore",
    "restore_log",
    "cluster_log", 
    "cluster_state",
    "node_state",
    "node_statistics",
    "cluster_statistics",
    "memory_usage",
    "mysql_server",
    "mysql_slave_status",
    "mysql_master_status",
    "mysql_statistics",
    "mysql_global_statistics",
    "mysql_variables",
    "diskdata",
    "schema_object",
    "cluster",
    "configurator_nodemap",
    "mailserver"
  };

static const int NO_TABLES=24;

bool checkSchema();

void createSchema(bool t);

		 
#define DROP_CLUSTER "DROP TABLE IF EXISTS `cluster`"
#define CREATE_CLUSTER "CREATE TABLE IF NOT EXISTS `cluster` ("	\
  " `id` int(11) NOT NULL AUTO_INCREMENT,"			\
  " `connectstring` CHAR(255) DEFAULT NULL,"                 \
  " `name` CHAR(255) DEFAULT NULL,"				\
  " `scriptsdir` CHAR(255) DEFAULT NULL,"			\
  " `description` CHAR(255) DEFAULT NULL,"			\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  " PRIMARY KEY (`id`),"					\
  " UNIQUE KEY (`connectstring`),"				\
  " KEY `report_ts` (`report_ts`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "


#define DROP_CONFIGURATOR_NODEMAP "DROP TABLE IF EXISTS `configurator_nodemap`"
#define CREATE_CONFIGURATOR_NODEMAP "CREATE TABLE IF NOT EXISTS `configurator_nodemap` (" \
  " `cid` int(11),"							\
  " `nodeid` int(11),"							\
  " `hostname` CHAR(255) DEFAULT NULL,"				\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  " PRIMARY KEY (`cid`,`nodeid`),"					\
  " KEY `report_ts` (`report_ts`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "


#define DROP_MAILSERVER "DROP TABLE IF EXISTS `mailserver`"
#define CREATE_MAILSERVER "CREATE TABLE IF NOT EXISTS `mailserver` ("	\
  " `username` char(64) DEFAULT NULL,"					\
  " `from_email` char(128) DEFAULT NULL,"				\
  " `password` char(64) DEFAULT NULL,"					\
  " `smtpserver` char(64) DEFAULT NULL,"				\
  " `smtpport` integer DEFAULT NULL,"					\
  " `use_ssl` integer DEFAULT NULL,"					\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  " PRIMARY KEY (`smtpserver`),"						\
  " KEY `report_ts` (`report_ts`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "



#define DROP_EMAIL_NOTIFICATION "DROP TABLE IF EXISTS `email_notification`"
#define CREATE_EMAIL_NOTIFICATION "CREATE TABLE IF NOT EXISTS `email_notification` (" \
  " `id` int(11) NOT NULL AUTO_INCREMENT,"				\
  " `cid` int(11) NOT NULL DEFAULT 0,"					\
  " `fname` CHAR(255) DEFAULT NULL,"					\
  " `lname` CHAR(255) DEFAULT NULL,"					\
  " `email` CHAR(255) DEFAULT NULL,"					\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  " PRIMARY KEY (`id`),"						\
  " UNiQUE KEY `ix_email` (`email`),"					\
  " KEY `ix_fname_email` (`fname`,`email`),"				\
  " KEY `ix_cid` (`cid`),"						\
  " KEY `ix_lname_email` (`lname`,`email`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "


#define DROP_BACKUP_LOG "DROP TABLE IF EXISTS `backup_log`"
#define CREATE_BACKUP_LOG "CREATE TABLE IF NOT EXISTS `backup_log` ("			\
  " `cid` int(11) NOT NULL DEFAULT '0',"                   \
  " `id` int(11) NOT NULL AUTO_INCREMENT,"			\
  " `backupid` int(11) NOT NULL DEFAULT '0',"			\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  " `status` CHAR(255) DEFAULT NULL,"			\
  " `error` int(11) NOT NULL DEFAULT '0',"			\
  " PRIMARY KEY (`id`),"					\
  " KEY `report_ts` (`report_ts`),"				\
  " KEY `backupid` (`backupid`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "




#define DROP_BACKUP "DROP TABLE IF EXISTS `backup`"
#define CREATE_BACKUP "CREATE TABLE IF NOT EXISTS `backup` ("                 \
  " `cid` int(11) NOT NULL DEFAULT '0',"                   \
  " `backupid` int(11) NOT NULL DEFAULT '0',"                   \
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"  \
  " `master_nodeid` int(11) NOT NULL DEFAULT '0',"              \
  " `mgm_nodeid` int(11) NOT NULL DEFAULT '0',"                 \
  " `status` CHAR(255) DEFAULT NULL,"                        \
  " `error` int(11) NOT NULL DEFAULT '0',"                      \
  " `start_gci` int(11) DEFAULT '0', "                          \
  " `stop_gci` int(11) DEFAULT '0',"                            \
  " `records` BIGINT UNSIGNED DEFAULT '0',"                             \
  " `log_records` BIGINT UNSIGNED DEFAULT '0',"                         \
  " `bytes` BIGINT UNSIGNED DEFAULT '0',"                               \
  " `log_bytes` BIGINT UNSIGNED DEFAULT '0',"                           \
  " PRIMARY KEY (`backupid`),"                                  \
  " KEY `report_ts` (`report_ts`)"                              \
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "




#define DROP_RESTORE_LOG "DROP TABLE IF EXISTS `restore_log`"
#define CREATE_RESTORE_LOG "CREATE TABLE IF NOT EXISTS `restore_log` ("			\
  " `cid` int(11) NOT NULL DEFAULT '0',"                   \
  " `id` int(11) NOT NULL AUTO_INCREMENT,"			\
  " `backupid` int(11) NOT NULL DEFAULT '0',"			\
  " `master_nodeid` int(11) NOT NULL DEFAULT '0',"              \
  " `mgm_nodeid` int(11) NOT NULL DEFAULT '0',"                 \
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  " `status` CHAR(255) DEFAULT NULL,"			\
  " `error` int(11) NOT NULL DEFAULT '0',"			\
  " PRIMARY KEY (`id`),"					\
  " KEY `report_ts` (`report_ts`),"				\
  " KEY `backupid` (`backupid`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "


#define DROP_RESTORE "DROP TABLE IF EXISTS `restore`"

#define CREATE_RESTORE "CREATE TABLE IF NOT EXISTS `restore` ("			\
  " `cid` int(11) NOT NULL DEFAULT '0',"                   \
  " `backupid` int(11) NOT NULL DEFAULT '0',"			\
  " `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  " `master_nodeid` int(11) NOT NULL DEFAULT '0',"		\
  " `ndb_nodeid` int(11) NOT NULL DEFAULT '0',"			\
  " `status` CHAR(255) DEFAULT NULL,"			\
  " `error` int(11) NOT NULL DEFAULT '0',"			\
  " `records` BIGINT UNSIGNED DEFAULT '0',"				\
  " `log_records` BIGINT UNSIGNED DEFAULT '0',"				\
  " `bytes` BIGINT UNSIGNED DEFAULT '0',"				\
  " `log_bytes` BIGINT UNSIGNED DEFAULT '0',"				\
  " `n_tables` INT UNSIGNED DEFAULT '0',"				\
  " `n_tablespaces` INT UNSIGNED DEFAULT '0',"				\
  " `n_logfilegroups` INT UNSIGNED DEFAULT '0',"			\
  " `n_datafiles` INT UNSIGNED DEFAULT '0',"				\
  " `n_undofiles` INT UNSIGNED DEFAULT '0',"				\
  " PRIMARY KEY (`backupid`, `ndb_nodeid`),"					\
  " KEY `report_ts` (`report_ts`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "




#define DROP_CLUSTER_LOG "DROP TABLE IF EXISTS `cluster_log`"

#define CREATE_CLUSTER_LOG "CREATE TABLE IF NOT EXISTS `cluster_log` ("		\
  "  `cid` int(11) NOT NULL,"				\
  "  `id` int(11) NOT NULL AUTO_INCREMENT,"				\
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "  `source_nodeid` int(11) NOT NULL DEFAULT '0',"			\
  "  `nodeid` int(11) NOT NULL DEFAULT '0',"				\
  "  `severity` enum('DEBUG','INFO','WARNING','ERROR','CRITICAL','ALERT') DEFAULT NULL," \
  "  `loglevel` int(11) NOT NULL DEFAULT '0',"				\
  "  `event` CHAR(255) DEFAULT NULL,"				\
  "  `message` CHAR(255) DEFAULT NULL,"				\
  "  PRIMARY KEY (`cid`,`id`),"						\
  "  KEY `report_ts` (`report_ts`),"					\
  "  KEY `severity` (`severity`),"					\
  "  KEY `event` (`event`)"						\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"				




#define DROP_CLUSTER_STATE "DROP TABLE IF EXISTS `cluster_state`"

#define CREATE_CLUSTER_STATE "CREATE TABLE IF NOT EXISTS  `cluster_state` ("		\
  "  `id` int(11) NOT NULL,"						\
  "  `status` enum('MGMD_NO_CONTACT', 'STARTED','NOT_STARTED','DEGRADED','FAILURE','SHUTTING_DOWN','RECOVERING','STARTING','UNKNOWN') DEFAULT NULL," \
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "  PRIMARY KEY (`id`)"						\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"				\
					    

#define DROP_MEMORY_USAGE "DROP TABLE IF EXISTS `memory_usage`"

#define CREATE_MEMORY_USAGE "CREATE TABLE IF NOT EXISTS  `memory_usage` ("		\
  "  `cid` int(11) NOT NULL DEFAULT '0',"				\
  "  `nodeid` int(11) NOT NULL DEFAULT '0',"				\
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "  `pg_used_im` int(11) DEFAULT '0',	"				\
  "  `pg_used_dm` int(11) DEFAULT '0',"					\
  "  `pg_tot_im` int(11) DEFAULT '0',"					\
  "  `pg_tot_dm` int(11) DEFAULT '0',"					\
  "  `pg_sz_dm` int(11) DEFAULT '0',"					\
  "  `pg_sz_im` int(11) DEFAULT '0',"					\
  "  `dm_used_mb` int(11) DEFAULT '0',"					\
  "  `im_used_mb` int(11) DEFAULT '0',"					\
  "  `dm_total_mb` int(11) DEFAULT '0',"				\
  "  `im_total_mb` int(11) DEFAULT '0',"				\
  "  PRIMARY KEY (`cid`,`nodeid`),"					\
  "  KEY `report_ts` (`report_ts`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"



#define DROP_NODE_STATE "DROP TABLE IF EXISTS `node_state`"


#define CREATE_NODE_STATE "CREATE TABLE IF NOT EXISTS  `node_state` (" \
  "  `cid` int(11) NOT NULL,"					\
  "  `nodeid` int(11) NOT NULL,"					\
  "  `status` enum('STARTED','NOT_STARTED','SINGLEUSER','RESUME','RESTARTING','SHUTTING_DOWN','NO_CONTACT','STARTING','UNKNOWN','CONNECTED','DISCONNECTED') DEFAULT NULL," \
  "  `node_type` enum('NDBD','API','NDB_MGMD') DEFAULT NULL,"		\
  "  `nodegroup` int(11) DEFAULT NULL,"					\
  "  `host` CHAR(32) DEFAULT NULL,"					\
  "  `version` CHAR(64) DEFAULT NULL,"				\
  "  `disconnects` int(11) DEFAULT '0',"				\
  "  `last_disconnect` datetime DEFAULT NULL,"				\
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "  PRIMARY KEY (`cid`,`nodeid`),"						\
  "  KEY (`node_type`,`nodeid`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"



#define DROP_NODE_STATISTICS "DROP TABLE IF EXISTS `node_statistics`"
#define CREATE_NODE_STATISTICS "CREATE TABLE IF NOT EXISTS  `node_statistics` ("\
  "  `cid` int(11) DEFAULT '0',"		       \
  "  `nodeid` int(11) DEFAULT '0',"		       \
  "  `operations` int(11) DEFAULT '0',"	       \
  "  `transactions` int(11) DEFAULT '0',"	       \
  "  `commits` int(11) DEFAULT '0',"	       \
  "  `writes` int(11) DEFAULT '0',"	       \
  "  `reads_lock` int(11) DEFAULT '0',"	       \
  "  `reads_nolock` int(11) DEFAULT '0',"	       \
  "  `aborts` int(11) DEFAULT '0',"	       \
  "  `attrs` int(11) DEFAULT '0',"		       \
  "  `scans` int(11) DEFAULT '0',"		       \
  "  `range_scans` int(11) DEFAULT '0',"	       \
  "  `conc_ops` int(11) DEFAULT '0',"			\
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  "  PRIMARY KEY (`cid`,`nodeid`),"					\
  "  KEY `report_ts` (`report_ts`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"




#define DROP_CLUSTER_STATISTICS "DROP TABLE IF EXISTS `cluster_statistics`"
#define CREATE_CLUSTER_STATISTICS "CREATE TABLE IF NOT EXISTS  `cluster_statistics` ("\
  "  `id` int(11) NOT NULL,"						\
  "  `operations` int(11) DEFAULT '0',"					\
  "  `transactions` int(11) DEFAULT '0',"				\
  "  `commits` int(11) DEFAULT '0',"					\
  "  `writes` int(11) DEFAULT '0',"					\
  "  `reads_lock` int(11) DEFAULT '0',"					\
  "  `reads_nolock` int(11) DEFAULT '0',"				\
  "  `aborts` int(11) DEFAULT '0',"					\
  "  `attrs` int(11) DEFAULT '0',"					\
  "  `scans` int(11) DEFAULT '0',"					\
  "  `range_scans` int(11) DEFAULT '0',"				\
  "  `conc_ops` int(11) DEFAULT '0',"					\
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "  PRIMARY KEY (`id`),"						\
  "  KEY `report_ts` (`report_ts`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"


#define DROP_MYSQL_VARIABLE "DROP TABLE IF EXISTS `mysql_variables`"
#define CREATE_MYSQL_VARIABLE "CREATE TABLE IF NOT EXISTS  `mysql_variables` ("\
  "  `cid` int(11),"	       \
  "  `mysqlid` int(11),"	       \
  "  `variable_name` CHAR(255) NOT NULL,"	       \
  "  `variable_value` CHAR(255),"	       \
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  "  PRIMARY KEY (`cid`,`mysqlid`,`variable_name`),"			\
  "  KEY `mysqlid_idx` (`mysqlid`,`report_ts`),"				\
  "  KEY `report_ts_idx` (`report_ts`)"				\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"


#define DROP_MYSQL_STATISTICS "DROP TABLE IF EXISTS `mysql_statistics`"
#define CREATE_MYSQL_STATISTICS "CREATE TABLE IF NOT EXISTS `mysql_statistics` (" \
  "`cid`INTEGER NOT NULL,"						\
  "`id`INTEGER NOT NULL,"						\
  "`nodeid`INTEGER NOT NULL,"						\
  "`var`  CHAR(64) NOT NULL,"						\
  "`value` BIGINT UNSIGNED DEFAULT 0,"					\
  "`report_ts` TIMESTAMP DEFAULT CURRENT_TIMESTAMP ,"			\
  "PRIMARY KEY (`cid`,`id`, `var`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "


#define DROP_MYSQL_GLOBAL_STATISTICS "DROP TABLE IF EXISTS `mysql_global_statistics`"
#define CREATE_MYSQL_GLOBAL_STATISTICS "CREATE TABLE IF NOT EXISTS `mysql_global_statistics` (" \
  "`var`  CHAR(64) NOT NULL,"						\
  "`value` BIGINT UNSIGNED DEFAULT 0,"					\
  "`report_ts` TIMESTAMP DEFAULT CURRENT_TIMESTAMP ,"			\
  "PRIMARY KEY (`var`)"							\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "

#if 0
#define CREATE_MYSQL_STATISTICS "CREATE TABLE IF NOT EXISTS `mysql_statistics` ("\
  "`cid`INTEGER NOT NULL,"					\
  "`id`INTEGER NOT NULL,"					\
  "`nodeid`INTEGER NOT NULL,"					\
  "`ABORTED_CLIENTS` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`ABORTED_CONNECTS` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`COM_SELECT` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`COM_UPDATE` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`COM_DELETE` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`COM_INSERT` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`COM_REPLACE` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`CONNECTIONS` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`CREATED_TMP_DISK_TABLES` BIGINT UNSIGNED DEFAULT 0,"	\
  "`CREATED_TMP_FILES` BIGINT UNSIGNED DEFAULT 0,"		\
  "`CREATED_TMP_TABLES` BIGINT UNSIGNED DEFAULT 0 ,"		\
  "`OPENED_TABLES` BIGINT UNSIGNED DEFAULT 0,"				\
  "`THREADS_CACHED` BIGINT UNSIGNED DEFAULT 0 ,"				\
  "`THREADS_CONNECTED` BIGINT UNSIGNED DEFAULT 0,"			\
  "`THREADS_CREATED` BIGINT UNSIGNED DEFAULT 0,"			\
  "`THREADS_RUNNING` BIGINT UNSIGNED DEFAULT 0 ,"			\
  "`UPTIME` BIGINT UNSIGNED DEFAULT 0 ,"					\
  "`report_ts` TIMESTAMP DEFAULT CURRENT_TIMESTAMP ,"			\
  "PRIMARY KEY (`cid`,`id`)"						\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1 "
#endif

#define DROP_MYSQL_SERVER "DROP TABLE IF EXISTS `mysql_server`"
#define CREATE_MYSQL_SERVER "CREATE TABLE IF NOT EXISTS  `mysql_server` ("\
  "  `id` int(11) NOT NULL AUTO_INCREMENT,"	       \
  "  `cid` int(11) NOT NULL,"	       \
  "  `nodeid` int(11) DEFAULT 0,"	       \
  "  `hostname` CHAR(255) NOT NULL,"	       \
  "  `username` CHAR(255) NOT NULL,"	       \
  "  `password` CHAR(255) NOT NULL,"	       \
  "  `role` enum('none', 'master', 'slave', 'mixed') DEFAULT 'none' ,"	       \
  "  `port` integer(11) NOT NULL,"	       \
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  "  `connected` tinyint not null default 0,"	\
  "  `msg` CHAR(255) NOT NULL,"	       \
  "  PRIMARY KEY (`id`),"					\
  "  UNIQUE KEY (`hostname`,`port`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"



#define DROP_DISKDATA "DROP TABLE IF EXISTS `diskdata`"
#define CREATE_DISKDATA "CREATE TABLE IF NOT EXISTS  `diskdata` ("\
  "  `cid` int(11) NOT NULL,"	       \
  "  `nodeid` int(11) NOT NULL,"	       \
  "  `file_name` CHAR(64) NOT NULL,"	       \
  "  `ts_name` CHAR(64) NOT NULL,"	       \
  "  `type` CHAR(64) NOT NULL,"	       \
  "  `logfile_group_name` CHAR(64) NOT NULL,"	\
  "  `free_extents` bigint unsigned NOT NULL,"	       \
  "  `total_extents` bigint unsigned NOT NULL,"	       \
  "  `extent_size` bigint unsigned NOT NULL,"	       \
  "  `initial_size` bigint unsigned NOT NULL,"	       \
  "  `maximum_size` bigint unsigned NOT NULL,"	       \
  "  `undo_buffer_size` bigint unsigned NOT NULL,"	       \
  "  `report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"	\
  "  PRIMARY KEY (`cid`,`nodeid`,`file_name`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"




#define DROP_SCHEMA_OBJECT "DROP TABLE IF EXISTS `schema_object`"
#define CREATE_SCHEMA_OBJECT "CREATE TABLE IF NOT EXISTS `schema_object` (" \
  "`id`  int(11) auto_increment NOT NULL,"				\
  "`cid` int(11) NOT NULL,"						\
  "`tableid`int(11) NOT NULL,"						\
  "`type` CHAR(64) DEFAULT NULL,"					\
  "`state` CHAR(16) DEFAULT NULL,"					\
  "`logging` enum('yes','no') DEFAULT NULL,"				\
  "`temp` enum('yes','no') DEFAULT NULL,"				\
  "`name` CHAR(255) DEFAULT NULL,"					\
  "`db` CHAR(255) DEFAULT NULL,"					\
  "`schema_name` CHAR(64) DEFAULT NULL,"				\
  "`report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  " PRIMARY KEY (`cid`,`id`)"					\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"
#define DROP_MYSQL_MASTER_STATUS "DROP TABLE IF EXISTS `mysql_master_status`"

#define CREATE_MYSQL_MASTER_STATUS "CREATE TABLE IF NOT EXISTS `mysql_master_status` (" \
  "`cid` int(11) NOT NULL,"						\
  "`id` int(11) NOT NULL,"						\
  "`File`CHAR(255) DEFAULT NULL,"					\
  "`Position` bigint DEFAULT 0,"					\
  "`report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "PRIMARY KEY(`cid`,`id`)"		\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"

#define DROP_ALARM "DROP TABLE IF EXISTS `alarm`"
#define CREATE_ALARM "CREATE TABLE IF NOT EXISTS `alarm` ("		\
  "`alarm_id`  bigint auto_increment NOT NULL,"				\
  "`cid` int(11) NOT NULL,"						\
  "`nodeid` int(11) NOT NULL,"						\
  "`component` char(64) NOT NULL,"					\
  "`alarm_name` char(64) NOT NULL,"					\
  "`alarm_count` int(11) NOT NULL,"					\
  "`alarm_sent` int(11) NOT NULL,"					\
  "`alarm_sent_count` int(11) NOT NULL,"				\
  "`alarm_last_sent` datetime,"						\
  "`cluster_state` CHAR(64) DEFAULT NULL,"				\
  "`severity` CHAR(64) DEFAULT NULL,"				\
  "`exit_message` CHAR(255) DEFAULT NULL,"				\
  "`description` CHAR(255) DEFAULT NULL,"				\
  "`recommendation` CHAR(255) DEFAULT NULL,"				\
  "`hostname` CHAR(128) DEFAULT NULL,"				\
  "`report_ts` timestamp NOT NULL,"					\
  "PRIMARY KEY(`alarm_id`),"						\
  "KEY(`cid`,`nodeid`, `component`, `alarm_name`)"			\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"


#define DROP_ALARM_LOG "DROP TABLE IF EXISTS `alarm_log`"
#define CREATE_ALARM_LOG "CREATE TABLE IF NOT EXISTS `alarm_log` ("	\
  "`id`  int(11) auto_increment NOT NULL,"				\
  "`alarm_id`  int(11) NOT NULL,"					\
  "`cid` int(11) NOT NULL,"						\
  "`nodeid` int(11) NOT NULL,"						\
  "`component` char(64) NOT NULL,"					\
  "`alarm_name` char(64) NOT NULL,"					\
  "`alarm_count` int(11) NOT NULL,"					\
  "`alarm_sent` int(11) NOT NULL,"					\
  "`alarm_sent_count` int(11) NOT NULL,"				\
  "`cluster_state` CHAR(64) DEFAULT NULL,"				\
  "`severity` CHAR(64) DEFAULT NULL,"				\
  "`exit_message` CHAR(255) DEFAULT NULL,"				\
  "`description` CHAR(255) DEFAULT NULL,"				\
  "`recommendation` CHAR(255) DEFAULT NULL,"				\
  "`hostname` CHAR(128) DEFAULT NULL,"				\
  "`report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "PRIMARY KEY(`id`),"							\
  "KEY(`alarm_id`),"							\
  "KEY(`cid`,`nodeid`)"							\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"



#define DROP_MYSQL_SLAVE_STATUS "DROP TABLE IF EXISTS `mysql_slave_status`"

#define CREATE_MYSQL_SLAVE_STATUS "CREATE TABLE IF NOT EXISTS `mysql_slave_status` (" \
  "`cid` int(11) NOT NULL,"						\
  "`id` int(11) NOT NULL,"						\
  "`epoch` BIGINT NOT NULL default 0,"					\
  "`serverid` int(11) NOT NULL default 0,"				\
  "`Slave_IO_State` CHAR(64) DEFAULT NULL,"				\
  "`Master_Host` CHAR(64) DEFAULT NULL,"				\
  "`Master_User` CHAR(64) DEFAULT NULL,"				\
  "`Master_Port` int(11) DEFAULT 0,"					\
  "`Connect_Retry` int(11) DEFAULT 0,"					\
  "`Master_Log_File` CHAR(64) DEFAULT NULL,"				\
  "`Read_Master_Log_Pos` int(11) DEFAULT 0,"				\
  "`Relay_Log_File` CHAR(64) DEFAULT NULL,"				\
  "`Relay_Log_Pos` int(11) DEFAULT 0,"					\
  "`Relay_Master_Log_File` CHAR(64) DEFAULT NULL,"			\
  "`Slave_IO_Running` CHAR(64) DEFAULT NULL,"			\
  "`Slave_SQL_Running` CHAR(64) DEFAULT NULL,"			\
  "`Replicate_Do_DB` CHAR(64) DEFAULT NULL,"				\
  "`Replicate_Ignore_DB` CHAR(64) DEFAULT NULL,"			\
  "`Replicate_Do_Table` CHAR(64) DEFAULT NULL,"			\
  "`Replicate_Ignore_Table` CHAR(64) DEFAULT NULL,"			\
  "`Replicate_Wild_Do_Table` CHAR(64) DEFAULT NULL,"			\
  "`Replicate_Wild_Ignore_Table` CHAR(64) DEFAULT NULL,"		\
  "`Last_Errno` int(11) DEFAULT 0,"					\
  "`Last_Error` CHAR(128) DEFAULT NULL,"				\
  "`Skip_Counter` int(11) DEFAULT 0,"					\
  "`Exec_Master_Log_Pos` int(11) DEFAULT 0,"				\
  "`Relay_Log_Space` int(11) DEFAULT 0,"				\
  "`Until_Condition` CHAR(128) DEFAULT 'None',"			\
  "`Until_Log_File` CHAR(64),"					\
  "`Until_Log_Pos` int(11) DEFAULT 0,"					\
  "`Master_SSL_Allowed` CHAR(64) DEFAULT 'No',"			\
  "`Master_SSL_CA_File` CHAR(64),"					\
  "`Master_SSL_CA_Path` CHAR(64),"					\
  "`Master_SSL_Cert` CHAR(64),"					\
  "`Master_SSL_Cipher` CHAR(64),"					\
  "`Master_SSL_Key` CHAR(64),"					\
  "`Seconds_Behind_Master` INT DEFAULT NULL,"			\
  "`Master_SSL_Verify_Server_Cert` CHAR(64) DEFAULT 'No',"		\
  "`Last_IO_Errno` int(11) DEFAULT 0,"					\
  "`Last_IO_Error` CHAR(128),"					\
  "`Last_SQL_Errno` int(11) DEFAULT 0,"					\
  "`Last_SQL_Error` CHAR(128),"					\
  "`Master_Bind` CHAR(128) DEFAULT '0.0.0.0',"			\
  "`report_ts` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,"		\
  "PRIMARY KEY(`cid`,`id`)"		\
  ") ENGINE=MyISAM DEFAULT CHARSET=latin1;"




#endif

