/* Copyright (C) 2008 severalnines.com

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */



#ifndef STATISTICS_H
#define STATISTICS_H


typedef struct
{
  unsigned int trans_count; 
  unsigned int commit_count; 
  unsigned int write_count;
  unsigned int abort_count;
  unsigned int attrinfo_count;
  unsigned int readlock_count;
  unsigned int nolockread_count;
  unsigned int scan_count;
  unsigned int range_scan_count;
  unsigned int concop_count;  
  unsigned int operation_count;
} statistics_t;


typedef struct
{
  unsigned int used_dm;
  unsigned int total_dm;
  unsigned int used_im;
  unsigned int total_im;
  unsigned int page_sz_dm;
  unsigned int page_sz_im;
} statistics_mem_t;


typedef struct
{
  char status[256];
  unsigned backup_id;
  unsigned error;
  unsigned start_gci;
  unsigned stop_gci;
  unsigned long long n_bytes64;
  unsigned long long n_log_bytes64;
  unsigned long long n_records64;
  unsigned long long n_log_records64;
} statistics_backup_t;


typedef struct
{
  char status[256];
  unsigned backup_id;
  unsigned error;
  unsigned int n_tables;
  unsigned int n_tablespaces;
  unsigned int n_logfilegroups;
  unsigned int n_datafiles;
  unsigned int n_undofiles;
  unsigned long long n_bytes64;
  unsigned long long n_log_bytes64;
  unsigned long long n_records64;
  unsigned long long n_log_records64;  
} statistics_restore_t;

				

#endif
