#!/bin/bash
mycnf=/etc/mysql/my.cnf
bindir=/usr/local/mysql//mysql/bin/

libdir=/usr/local/mysql//mysql/lib/

TEMP=`getopt -o \?p:P:h:f:c: --long help,hostname:,port:,config-file:,clusterid: -n 'cmon_remove_mysqld.sh' -- "$@"`
eval set -- "$TEMP"
password=""
username=""
port=""
hostname=""
configfile=""
clusterid=""
help=""
while true ; do
    case "$1" in
        -h|--hostname) hostname="$2" ; shift 2 ;;
        -P|--port) port="$2" ; shift 2 ;;             
	-c|--clusterid) clusterid="$2" ; shift 2 ;;   
	-f|--config-file) configfile="$2" ; shift 2 ;;
        -\?|--help) help="1" ; shift ;;
        --) shift ; break ;;
        *) echo "Internal error!" ; exit 1 ;;
    esac
done
if [ -n "${help}" ]  ; then 
    echo "cmon_remove_mysqld.sh" >&2 ; 
    echo "-h | --hostname=<hostname>- hostname of mysql server to remove">&2; 
    echo "-P | --port=<port>- port of mysql server to remove. Default 3306.">&2; 
    echo "-f | --config-file=<password> - cmon.conf file (default ../etc/cmon.conf)">&2; 
    echo "-f | --clusterid=<clusterid> - the clusterid (integer) to remove this mysqld from">&2; 
    echo "" 
    exit 1 ; 
fi


if [ "${hostname}" = "" ]; then
    echo "Must specify hostname of mysqld to remove"
    exit;
fi


if [ "${clusterid}" = "" ]; then
    echo "clusterid is missing!"
    exit;
fi

if [ "${configfile}" = "" ]; then
    echo "Using default config file path ../etc/cmon.conf"
    configfile="../etc/cmon.conf"
fi


if [ "${port}" = "" ]; then
    port=3306    
fi


if [ ! -f ${configfile} ];
then
    echo "Could not find config file. Specify the file with --config-file"    
    exit
fi

source $configfile

query="DELETE FROM cmon.mysql_server WHERE hostname='$hostname' AND port=$port"


if [ -z "${MYSQL_PASSWORD}" ]; then
    `$MYSQL_PATH/mysql -u${MYSQL_USER} -h${MYSQL_HOST} -P${MYSQL_PORT} --execute "$query"`
else
    `$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD} -h${MYSQL_HOST} -P${MYSQL_PORT} --execute "$query"`
fi