#Copyright (C) 2008 severalnines.com                                                                                
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or  
#(at your option) any later version. 
#This program is distributed in the hope that it will be useful,  
#but WITHOUT ANY WARRANTY; without even the implied warranty of 
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#You should have received a copy of the GNU General Public License 
#along with this program; if not, write to the Free Software
#
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#!/bin/bash

RRD_CONF=$1

if [ -z ${RRD_CONF} ];
then
   echo "usage:"
   echo "./update_graphs <path to rrd.conf> "
exit
fi

source $RRD_CONF
clusters=""
if [ -z "${MYSQL_PASSWORD}"  ]; then
    clusters=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT}  -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(' ', id) FROM cmon.cluster_state"`
else
    clusters=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -p${MYSQL_PASSWORD} -h${MYSQL_HOST} --batch  --skip-column-names --execute   "SELECT concat_ws(' ', id) FROM cmon.cluster_state"`
fi
if [ -z "$clusters" ]; then
   echo "no clusters found -update"
   exit
fi

for cluster in ${clusters}
do
   ##CLUSTER STATISTICS
   if [ -z "${MYSQL_PASSWORD}"  ]; then
       data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',transactions, operations, commits, writes, reads_lock, reads_nolock, aborts, range_scans, scans, conc_ops) FROM cmon.cluster_statistics WHERE id=${cluster}"`
   else
       data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',transactions, operations, commits, writes, reads_lock, reads_nolock, aborts, range_scans, scans, conc_ops) FROM cmon.cluster_statistics WHERE id=${cluster}"`
   fi
   if [ -z "$data" ]; then
      	$RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_stats.rrd N:0:0:0:0:0:0:0:0:0:0
   else
        $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_stats.rrd N:$data
   fi

   ##MEMORY USAGE CLUSTER

   if [ -z "${MYSQL_PASSWORD}"  ]; then
       data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',ceiling(sum(pg_used_dm)*pg_sz_dm/1024/1024), floor(sum(pg_tot_dm-pg_used_dm)*pg_sz_dm/1024/1024),ceiling(sum(pg_used_im)*pg_sz_im/1024/1024), floor(sum(pg_tot_im-pg_used_im)*pg_sz_im/1024/1024)) FROM cmon.memory_usage WHERE cid=${cluster}"`
   else
       data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',ceiling(sum(pg_used_dm)*pg_sz_dm/1024/1024), floor(sum(pg_tot_dm-pg_used_dm)*pg_sz_dm/1024/1024),ceiling(sum(pg_used_im)*pg_sz_im/1024/1024), floor(sum(pg_tot_im-pg_used_im)*pg_sz_im/1024/1024)) FROM cmon.memory_usage WHERE cid=${cluster}"`
   fi
   if [ -z "$data" ]; then
        $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_memstats.rrd N:0:0:0:0
   else
        $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_memstats.rrd N:$data
   fi



##MYSQL STATISTICS (TOTAL)
   if [ -z "${MYSQL_PASSWORD}"  ]; then
     data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute  "SELECT GROUP_CONCAT(value SEPARATOR ':') FROM cmon.mysql_global_statistics WHERE var IN ('COM_SELECT', 'COM_INSERT', 'COM_UPDATE', 'COM_DELETE', 'COM_REPLACE') ORDER BY var"`
  else
     data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD} -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute  "SELECT GROUP_CONCAT(value SEPARATOR ':') FROM cmon.mysql_global_statistics WHERE var IN ('COM_SELECT', 'COM_INSERT', 'COM_UPDATE', 'COM_DELETE', 'COM_REPLACE') ORDER BY var"`
   fi
  
  if [ "$data" = "NULL" ]; then
      $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_mysql_stats.rrd N:0:0:0:0:0
   else
       $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_mysql_stats.rrd N:$data
   fi

    if [ -z "${MYSQL_PASSWORD}"  ]; then
	datanodes=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -h${MYSQL_HOST} -P${MYSQL_PORT}  --batch  --skip-column-names --execute   "SELECT concat_ws(' ', nodeid) FROM cmon.node_state WHERE cid=${cluster} AND node_type='NDBD'"`
    else
	datanodes=`$MYSQL_PATH/mysql -u${MYSQL_USER} -h${MYSQL_HOST} -P${MYSQL_PORT} -p${MYSQL_PASSWORD} --batch  --skip-column-names --execute   "SELECT concat_ws(' ', nodeid) FROM cmon.node_state WHERE cid=${cluster} AND node_type='NDBD'"`
    fi


   for datanode in ${datanodes}
   do
       ##NODE STATISTICS
       if [ -z "${MYSQL_PASSWORD}"  ]; then
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',transactions, operations, commits, writes, reads_lock, reads_nolock, aborts, range_scans, scans, conc_ops) FROM cmon.node_statistics WHERE cid=${cluster} AND nodeid=${datanode}"`
       else
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD} -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',transactions, operations, commits, writes, reads_lock, reads_nolock, aborts, range_scans, scans, conc_ops) FROM cmon.node_statistics WHERE cid=${cluster} AND nodeid=${datanode}"`
       fi
   	if [ -z "$data" ]; then
       		$RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_node_${datanode}_stats.rrd N:0:0:0:0:0:0:0:0:0:0
   	else
                $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_node_${datanode}_stats.rrd N:$data
   	fi


       ##MEMORY STATISTICS
       if [ -z "${MYSQL_PASSWORD}"  ]; then
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',ceiling(sum(pg_used_dm)*pg_sz_dm/1024/1024), floor(sum(pg_tot_dm-pg_used_dm)*pg_sz_dm/1024/1024),ceiling(sum(pg_used_im)*pg_sz_im/1024/1024), floor(sum(pg_tot_im-pg_used_im)*pg_sz_im/1024/1024)) FROM cmon.memory_usage WHERE cid=${cluster} AND nodeid=${datanode}"`
       else
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(':',ceiling(sum(pg_used_dm)*pg_sz_dm/1024/1024), floor(sum(pg_tot_dm-pg_used_dm)*pg_sz_dm/1024/1024),ceiling(sum(pg_used_im)*pg_sz_im/1024/1024), floor(sum(pg_tot_im-pg_used_im)*pg_sz_im/1024/1024)) FROM cmon.memory_usage WHERE cid=${cluster} AND nodeid=${datanode}"`
       fi
   	if [ -z "$data" ]; then
             $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_node_${datanode}_memstats.rrd N:0:0:0:0
   	else
             $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_node_${datanode}_memstats.rrd N:$data
   	fi
   done

   if [ -z "${MYSQL_PASSWORD}"  ]; then
       mysqlservers=`$MYSQL_PATH/mysql -u${MYSQL_USER} -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(' ', concat(hostname,'|',port) ) FROM cmon.mysql_server WHERE cid=${cluster}"`

   else
       mysqlservers=`$MYSQL_PATH/mysql -u${MYSQL_USER} -P${MYSQL_PORT} -p${MYSQL_PASSWORD} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT concat_ws(' ', concat(hostname,'|',port) ) FROM cmon.mysql_server WHERE cid=${cluster}"`
   fi
   
   for mysqlserver in ${mysqlservers}
   do
       hname=`echo $mysqlserver | awk -F "|" '{print $1;}'`
       port=`echo $mysqlserver | awk -F "|" '{print $2;}'`
       if [ -z "${MYSQL_PASSWORD}"  ]; then
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT group_concat(value SEPARATOR ':') FROM cmon.mysql_statistics, cmon.mysql_server WHERE mysql_server.cid=${cluster} and mysql_server.hostname='${hname}' and mysql_server.port=$port and mysql_server.id=mysql_statistics.id and mysql_statistics.var in ('COM_SELECT', 'COM_INSERT', 'COM_UPDATE', 'COM_DELETE', 'COM_REPLACE') "`
       else
	   data=`$MYSQL_PATH/mysql -u${MYSQL_USER} -p${MYSQL_PASSWORD}  -P${MYSQL_PORT} -h${MYSQL_HOST}  --batch  --skip-column-names --execute   "SELECT group_concat(value SEPARATOR ':') FROM cmon.mysql_statistics, cmon.mysql_server WHERE mysql_server.cid=${cluster} and mysql_server.hostname='${hname}' and mysql_server.port=$port and mysql_server.id=mysql_statistics.id and mysql_statistics.var in ('COM_SELECT', 'COM_INSERT', 'COM_UPDATE', 'COM_DELETE', 'COM_REPLACE') "`

       fi
       if [ -z "$data" ]; then
           $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_mysql_${mysqlserver}_stats.rrd N:0:0:0:0:0
       else
           $RRD_TOOL update $RRD_DATADIR/cluster_${cluster}_mysql_${mysqlserver}_stats.rrd N:$data
       fi

   done

done
