<?php
/* Copyright (C) 2008 severalnines.com                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or  
(at your option) any later version. 
This program is distributed in the hope that it will be useful,  
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software

Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

function print_manage_view_html($action, $id, $nodeid)
{	
	require_once("helpers/helpers_cluster.php");
	$longtext=get_long_text($action);
	$type=get_node_type($id, $nodeid);


	$name=get_cluster_name($id);
	if($name=="")
	  $name=$id;
	if($nodeid==0)
	{	
		print("<h2>$longtext of cluster '$name'</h2>\n");
	}
	else
		print("<h2>$longtext of $type node $nodeid on '$name'</h2>\n");

	
	print("<div class=\"detail-box\">\n");
	if($action=="stop" || $action=="stopcluster")
 	{
    	  print("<img src=\"img/stop.jpg\" align=\"left\"/>\n");
	  if($action=="stop" && $type=="NDBD")
              print("<br>Stopping the node will bring the cluster into 'DEGRADED' state.<br>");
	  if($action=="stopcluster")
	      print("<br>Stopping the cluster will shutdown the ndb_mgmd(s), ndbd(s), and mysqld(s).<br>");
        }
        if($action=="restart" || $action == "rolling")
	{
          print("<img src=\"img/update.png\" align=\"left\"/>\n");
	  print("<br>Restarting the node(s) will bring the cluster into 'DEGRADED' state for the duration of the $longtext. There is no service interruption.<br>"); 
	  print("Choose 'intial' if you have done a configuration change affecting the disk (NoOfFragmentLogfiles, FragmentLogFileSize, DataDir)<br>"); 
        }

	print("Press the 'proceed' button to continue.\n");
	print ("<form action=\"manage.php?action=$action&id=$id&nodeid=$nodeid\" method=\"get\"><table width=\"80%\">");
	if($action=="start" || $action=="restart" || $action=="rolling")
	  print("Initial $action?: <input type=\"checkbox\" name=\"initial\" value=\"1\" />\n");
       	print ("<input type=\"hidden\" name=\"action\" value=\"$action\"/>"); 
       	print ("<input type=\"hidden\" name=\"id\" value=\"$id\"/>"); 
       	print ("<input type=\"hidden\" name=\"nodeid\" value=\"$nodeid\"/>"); 
	print ("<input tabindex=\"2\" name=\"submit\" type=\"submit\" value=\"proceed\"/>");
	print ("</form>");
	print("</div>\n");
}



function print_manage_proceed_html($action, $id, $nodeid, $initial)
{	
	require_once("helpers/helpers_cluster.php");
	$longtext=get_long_text($action);
	$type=get_node_type($id, $nodeid);


	$name=get_cluster_name($id);
	if($name=="")
	  $name=$id;
	if($nodeid==0)
	{	
		print("<h2>Executing $longtext of cluster '$name'</h2>\n");
	}
	else
		print("<h2>Executing $longtext of $type node $nodeid on '$name'</h2>\n");

	
	print("<div class=\"detail-box\">\n");
	if($action=="stop" || $action=="stopcluster")
 	{
    	  print("<img src=\"img/stop.jpg\" align=\"left\"/>\n");
        }
        if($action=="restart" || $action == "rolling")
	{
          print("<img src=\"img/update.png\" align=\"left\"/>\n");
        }
	if(!execute_action($action, $nodeid, $id, $initial))
	{
		die("failed..");
	}
	else
	{
		print("<br>cool...<br>");
	}
	print("</div>\n");
}

function execute_action($action, $nodeid, $id, $initial)
{	 
	require_once("helpers/helpers_cluster.php");
	$hostname=get_hostname_from_map($id,$nodeid);
	$type=get_node_type($id, $nodeid);
	$status=get_node_status($id, $nodeid);
	$scriptdir=get_scriptdir($id);
	$long_text=get_long_text($action);

	if($hostname=="" || scriptdir=="")
	  return false;
	$scriptdir=$scriptdir . "/cluster/scripts/";
	$script="";
	if($action=="stop")
        {
	    $connected=is_started($nodestatus) | is_connected($nodestatus);
            if(!$connected)
	    {
	       print("The node is neither STARTED or CONNECTED, so aborting $long_text");
	       return false;
	    }
            if($type=="NDBD")
	      	  $script="./stop-ndbd-$hostname-id-$nodeid.sh";
            if($type=="API")
	      	  $script="./start-mysqld-$hostname.sh";
	}

	if($action=="start")
        {
	    $connected=is_started($nodestatus) | is_connected($nodestatus);
            if($connected)
	    {
	       print("The node is either STARTED or CONNECTED, so aborting $long_text");
	       return false;
	    }
            if($type=="NDBD" && $initial)
	      	  $script="./start-ndbd-$hostname-id-$nodeid-initial.sh";
            if($type=="NDBD" && !$initial)
	      	  $script="./start-ndbd-$hostname-id-$nodeid.sh";
            if($type=="API")
	      	  $script="./start-mysqld-$hostname.sh";
	}
	if($script==$scriptdir)
	   return false;
	
	$exec_cmd="cd $scriptdir && $script";
	echo $exec_cmd;
	$output=shell_exec("$exec_cmd");
	$status=get_node_status($id, $nodeid);
	print("The $type with id=$id on $hostname is in state $status<br>");
	return true;	  
}

function get_long_text($action)
{
	if($action=="stop")
	  return "STOP";
	if($action=="start")
	  return "START";
	if($action=="restart")
	  return "RESTART";
	if($action=="rolling")
	  return "ROLLING RESTART";
	if($action=="stopcluster")
	  return "STOP CLUSTER";
	if($action=="startcluster")
	  return "START CLUSTER";
}

?>